""" Support for mounting a filestorage. 
    Code derived from the original OFS/MountedItem.py which has now disappeared
    from the CVS.

    Use at your own risk. There's probably gods only know special badness 
    awaiting users of this. 
"""

import Globals
import ZEO.ClientStorage

from MountedStorage import MountedStorageMixin, MountedStorage

class ClientStorageMixin(MountedStorageMixin):
    def _createStorage(self):
	""" Gets the Storage object.
        """
        params = eval(eval(self._params))
        host = params['host']
        port = int(params['port'])
        name = '%s@%s:%s' % (params['storage'], params['host'], params['port'])
        storage = params['storage']
        path = self._path
        create = self._create
        
        return ZEO.ClientStorage.ClientStorage(connection=(host,port),name=name,storage=storage,wait_for_server_on_startup=0,client=None)

class ClientStorage(ClientStorageMixin, MountedStorage):
    '''A MountPoint with a basic interface for displaying the
    reason the database did not connect.
    '''

    meta_type = 'MountedClientStorage'
    
    def __init__(self, id, host, port, storage, title='', path=None, create=None):
        params = {'host':host,'port':port,'storage':storage}
        MountedStorage.__init__(self,id,title,path,create,params)

manage_addClientStorageForm=Globals.HTMLFile('dtml/addClientStorage',globals())

def manage_addClientStorage(self,id,host,port,storage,title='',path=None,create=None,REQUEST=None):
    """ add a mountpoint """
    ms = ClientStorage(id, host, port, storage, title, path, create)
    self._setObject(id, ms)
    if REQUEST is not None:
	return self.manage_main(self, REQUEST)
